// ======================================================================
//
// TextureManager_3dfx.h
// jeff grills
//
// copyright 1998 origin systems inc
//
// ======================================================================

#ifndef TMM_3DFX_H
#define TMM_3DFX_H

// ======================================================================

class StaticMaterial;
class MaterialData_3dfx;

// ======================================================================

class TextureManager
{
private:

	struct TextureBlock
	{
		int                      region;
		u_int32                  location;
		int                      length;
		const MaterialData_3dfx *userData;
		TextureBlock            *previous;
		TextureBlock            *next;

		TextureBlock(int newRegion, u_int32 newLocation, int newLength);
	};

private:

	static TextureBlock *first;

public:

	static void install(void);
	static void remove(void);
	static void debugDump(void);

	static void addRegion(int region, u_int32 location, int length);

	static u_int32 alloc(int size, const MaterialData_3dfx *userData);
	static void    free(u_int32 location);
};

// ======================================================================

#endif
